package weixiao.servlet;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.rmi.server.ExportException;
import java.security.MessageDigest;
import java.util.*;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

import weixiao.util.HttpUtil;

@WebServlet("/index")
public class index extends HttpServlet {

	// 微校示例APP_KEY和APP_SECRET，需要开发者改成应用的APP_KEY和APP_SECRET
	public static final String APP_KEY = "BE30B2BA30ABFADB";
	public static final String APP_SECRET = "CF8CDD8D0B7B1ACDA76201F406BED81E";

	// 获取应用ACCESS_TOKEN请求地址
	public static final String APP_ACCESS_TOKEN = "https://uni.weixiao.qq.com/open/cgi-bin/access-token";

	// 获取当前登录管理员身份态请求地址
	public static final String MANAGER_INFO = "https://uni.weixiao.qq.com/open/cgi-bin/get-manager-info";

	// 获取学校ACCESS_TOKEN请求地址
	public static final String CAMPUS_ACCESS_TOKEN = "https://uni.weixiao.qq.com/open/cgi-bin/campus-access-token";

	// 获取学校组织结构请求地址
	public static final String CAMPUS_ORGANIZATION = "https://uni.weixiao.qq.com/open/cgi-bin/user/organization-list";

 	// 获取组织架构成员请求地址
	public static final String CAMPUS_ORGANIZE_USER_LIST = "https://uni.weixiao.qq.com/open/cgi-bin/user/org-user-list";

	// 获取多个组织架构的成员请求地址
	public static final String CAMPUS_ORGANIZES_UER_LIST = "https://uni.weixiao.qq.com/open/cgi-bin/user/orgs-user-list";

	// 获取标签列表请求地址
	public static final String CAMPUS_TAG_LIST = "https://uni.weixiao.qq.com/open/cgi-bin/user/tag-list";

	// 获取单个标签的成员请求地址
	public static final String CAMPUS_TAG_USER_LIST = "https://uni.weixiao.qq.com/open/cgi-bin/user/tag-user-list";

	// 获取多个标签的成员请求地址
	public static final String CAMPUS_TAGS_USER_LIST = "https://uni.weixiao.qq.com/open/cgi-bin/user/tags-user-list";

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		request.setCharacterEncoding("UTF-8");
		response.setCharacterEncoding("UTF-8");
		switch (request.getParameter("type")) {
		case "open":
			open(request, response);
			break;
		case "close":
			close(request, response);
			break;
		case "trigger":
			trigger(request, response);
			break;
		case "manage":
			manage(request, response);
			break;
		case "monitor":
			monitor(request, response);
			break;
		default:
			break;
		}
	}
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

	/**
	 * 开启应用
	 * 
	 * @return
	 * @throws IOException
	 */
	public void open(HttpServletRequest request, HttpServletResponse response) throws IOException {
		Map<String, String> map = getPostParameter(request);

		Map<String, String> resultMap = verifySign(map);
		if (resultMap.get("errcode").equals("0")) {
			// TODO:与学校有关的业务逻辑
		
			// 为每一个学校生成一个唯一的小程序码，并提交访问链接
			String mnpQrcode = "http://weixiao.qq.com/upload/mnp_wxacode/fac9b61496923103.jpg";

			resultMap = new TreeMap();
			resultMap.put("errcode", "0");
			resultMap.put("errmsg", "ok");
			resultMap.put("mnp_qrcode", mnpQrcode);

			response.getWriter().write(mapToJson(resultMap));
		} else {
			// 返回错误信息
			response.getWriter().write(mapToJson(resultMap));
		}

	}

	/**
	 * 关闭应用
	 * 
	 * @return
	 */
	public void close(HttpServletRequest request, HttpServletResponse response) throws IOException {
		Map<String, String> map = getPostParameter(request);

		Map<String, String> resultMap = verifySign(map);
		if (resultMap.get("errcode").equals("0")) {

			// TODO:与学校有关的业务逻辑
		
			resultMap = new TreeMap();
			resultMap.put("errcode", "0");
			resultMap.put("errmsg", "ok");

			response.getWriter().write(mapToJson(resultMap));
		} else {
			// 返回错误信息
			response.getWriter().write(mapToJson(resultMap));
		}
	}

	/**
	 * 应用触发(H5)
	 * 
	 * @return
	 */
	public void trigger(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String schoolCode = request.getParameter("school_code");
		String mediaId = request.getParameter("media_id");

		// 根据学校和学校主公众号生成移动端访问链接
		String redirectUrl = "https://weixiao.qq.com";

		response.sendRedirect(redirectUrl);
	}


	/**
	 * 应用后台管理
	 * 
	 * @return
	 */
	public void manage(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String wxcode = request.getParameter("wxcode");
		String state = request.getParameter("state");

		// 管理后台业务逻辑，可返回页面或进行跳转
	}

	/**
	 * 应用监控
	 * 
	 * @return
	 */
	public void monitor(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String echoStr = request.getParameter("echostr");

		response.getWriter().write(echoStr);
	}

	/**
	 * 获取POST参数
	 */
	public Map<String, String> getPostParameter(HttpServletRequest request) {
		Map<String, String> requestMap = new TreeMap<String, String>();

		StringBuffer data = new StringBuffer();
		String line = null;
		BufferedReader reader = null;
		try {
			reader = request.getReader();
			while (null != (line = reader.readLine())) {
				data.append(line);
			}
		} catch (IOException e) {
		}

		// 兼容旧的写法
		if (data.toString().equals("")) {
			Map<String, String[]> map = request.getParameterMap();

			for (String param : map.keySet()) {
				if (param.indexOf("school_code") != -1) {
					data = new StringBuffer(param);
				}
			}
		}

		JSONObject json = JSON.parseObject(data.toString());
		for (String key: json.keySet()) {
			requestMap.put(key, json.getString(key));
		}

		return requestMap;
	}

	/**
	 * 生成随机字符串
	 * 
	 * @param length
	 * @return
	 */
	public static String getRandomString(int length) {
		String base = "abcdefghijklmnopqrstuvwxyz0123456789";
		Random random = new Random();
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < length; i++) {
			int number = random.nextInt(base.length());
			sb.append(base.charAt(number));
		}
		return sb.toString();
	}

	/**
	 * MD5
	 * 
	 * @param srcString
	 * @return
	 */
	public final static String md5Encode(String srcString) {
		char hexDigits[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
		try {
			byte[] strTemp = srcString.getBytes("UTF-8");
			MessageDigest messageDigest = MessageDigest.getInstance("MD5");
			messageDigest.update(strTemp);
			byte[] mdByte = messageDigest.digest();
			int j = mdByte.length;
			char str[] = new char[j * 2];
			int k = 0;
			for (int i = 0; i < j; i++) {
				byte byte0 = mdByte[i];
				str[k++] = hexDigits[byte0 >>> 4 & 0xf];
				str[k++] = hexDigits[byte0 & 0xf];
			}
			return new String(str);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * 计算签名
	 * 
	 * @param map
	 * @return
	 */
	public static String calSign(Map<String, String> map) {
		String str = "";
		for (Map.Entry<String, String> entry : map.entrySet()) {
			str += entry.getKey() + "=" + entry.getValue() + "&";
		}
		str += "key=" + APP_SECRET;
		return md5Encode(str).toUpperCase();
	}

	/**
	 * 验证签名
	 * 
	 * @param map
	 * @return
	 */
	public static Map<String, String> verifySign(Map<String, String> map){
		String signature = map.remove("signature");

		// 计算签名
		String calSign = calSign(map);

		Map<String, String> requestMap = new TreeMap<String, String>();

		/** 验证签名 */
		if (calSign.equals(signature)) {
			Long localTime = Long.parseLong(String.valueOf(System.currentTimeMillis()).toString().substring(0, 10));
			Long wxTime = Long.parseLong((map.get("timestamp")));
			long timeS = localTime - wxTime;
			/** 检查时间戳 */
			if (timeS >= 0 && timeS < 10) {
				requestMap.put("errcode", "0");
				requestMap.put("errmsg", "");
			} else {
				requestMap.put("errcode", "5003");
				requestMap.put("errmsg", "请求接口失败");
			}
		} else {
			requestMap.put("errcode", "5004");
			requestMap.put("errmsg", "签名错误");
		}

		return requestMap;
	}

	/**
	 * 将map对象转化为json字符串
	 * @author batchen
	 * @param  map [description]
	 * @return     [description]
	 */
	public static String mapToJson(Map<String, String> map) {
		StringBuffer json = new StringBuffer();
		
		JSONObject jsonObject = new JSONObject();
		for (Map.Entry<String, String> entry : map.entrySet()) {
			jsonObject.put(entry.getKey(), entry.getValue());
		}

		return jsonObject.toString();
	}

}
